#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include <iostream>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <cassert>

using namespace std;

#define SQR(x) ((x)*(x))

const int steps = 1000000;
const int inf = 1e6;

double dist(double x, double y, double x1, double y1, double x2, double y2)
{
    double a = y2-y1;
    double b = x1-x2;
    double c = x2*y1 - x1*y2;
    return (a*x + b*y + c) / sqrt(a*a + b*b);
}

int main()
{
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
    
    double x, y, R, x1, y1, x2, y2, a;
    cin >> x >> y >> R;
    cin >> x1 >> y1 >> x2 >> y2 >> a;
    
    double d = sqrt(SQR(x2-x1) + SQR(y2-y1));
    assert(d <= 2*a);
    double b = sqrt(a*a - d*d/4);
    
    //  ,   
    //      ,   
    double dy = dist(x, y, x1, y1, x2, y2);
    double dx = dist(x, y, (x1+x2)/2, (y1+y2)/2, (x1+x2)/2 - (y2-y1), (y1+y2)/2 + (x2-x1));
    
    double Lx = max(-a, dx-R);
    double Rx = min(a, dx+R);
    double ans = 0;
    if (Lx < Rx) {
        double delta = (Rx - Lx) / steps;
        double cur_x = Lx;
        for (int i = 0; i < steps; i++) {
            cur_x += delta;
            double Ly = -inf, Ry = inf;
            if (dx-R < cur_x && cur_x < dx+R) {
                double circle_delta = sqrt(SQR(R) - SQR(cur_x - dx));
                Ly = max(Ly, dy - circle_delta);
                Ry = min(Ry, dy + circle_delta);
            }
            if (-a <= cur_x && cur_x <= a) {
                double ellipse_delta = b * sqrt(1 - cur_x*cur_x/a/a);
                Ly = max(Ly, -ellipse_delta);
                Ry = min(Ry, ellipse_delta);
            }
            
            //         
            ans += (Ry == inf || Ly > Ry) ? 0 : Ry-Ly; 
        }
        ans *= delta;
    }
    
    cout << fixed << setprecision(4) << ans << endl;
    
    fclose(stdin); fclose(stdout);
    return 0;   
}
